#!/usr/bin/env python3
#
# 200 lines with bugs
#
# This program should calculate the median colour of an image supplied in the PNG format

import sys
import png
from collections import defaultdict 

def calc_median_colour(filename):
    #print("Processing {}".format(filename))
    r = png.Reader(filename=filename)
    rgb = r.asRGBA8()
    data = rgb[2]

    counts = [0,0,0,0]
    i = 0
    for row in data:
        for v in row:
            counts[i % 4] += v
            i += 1

    i /= 4
    print("{}: [{}, {}, {}, {}]".format(filename, 
        int(counts[0] / i), int(counts[1] / i), int(counts[2] / i), int(counts[3] / i)))



def main():
    #print('Argument List:', str(sys.argv[1:]))
    files = sys.argv[1:]

    if len(files) == 0:
        sys.exit('No arguments supplied')
    
    for file in files:
        calc_median_colour(file)

if __name__ == '__main__':
    main()
