#!/usr/bin/env python3

import png

def ramp():
    f = open('ramp.png', 'wb')      # binary mode is important
    w = png.Writer(256, 1, greyscale=True)
    w.write(f, [range(256)])
    f.close()

def palette():
    s = ['110010010011',
     '101011010100',
     '110010110101',
     '100010010011']
    s = [[int(c) for c in row] for row in s]

    palette=[(0x55,0x55,0x55), (0xff,0x99,0x99)]
    w = png.Writer(len(s[0]), len(s), palette=palette, bitdepth=1)
    f = open('palette.png', 'wb')
    w.write(f, s)

def colour():
    height = 200
    width = 300
    px = [
        (255,0,0),
        (0,255,0),
        (0,0,255),
        (128,0,0),
        (0,128,0),
        (0,0,128),
    ]
    
    buffer = []
    for y in range(0, height):
        row = []
        for x in range(0, width):
            idx = int(3 * x / width)
            if y > height / 2:
                idx += 3

            p = px[idx]
            row.append(p[0])
            row.append(p[1])
            row.append(p[2])
        buffer.append(row)

    f = open('colour.png', 'wb')
    w = png.Writer(300, 200, greyscale=False)
    w.write(f, buffer)
    f.close()

ramp()
palette()
colour()
