#!/usr/bin/env python3
#
# 200 lines with bugs
#
# This program should calculate the median colour of an image supplied in the PNG format

import sys
import png
from collections import defaultdict 

def calc_median_colour(filename):
    #print("Processing {}".format(filename))
    r = png.Reader(filename=filename)
    rgb = r.asRGBA8()
    data = rgb[2]

    counts = defaultdict(int) 
    for row in data:
        p = []
        for v in row:
            p.append(v)
            if len(p) == 4:
                #print("p: {}".format(p))
                counts["{}".format(p)] += 1
                p.clear()

    sorted_pixels = sorted(counts.items(), key=lambda x: x[1], reverse=True)
    for p in sorted_pixels:
        print("{}: {}".format(filename, p[0]))
        return



def main():
    files = sys.argv[1:]

    if len(files) == 0:
        sys.exit('No arguments supplied')
    
    for file in files:
        calc_median_colour(file)

if __name__ == '__main__':
    main()
